#include <stdio.h>
#include <stdlib.h>
#include <math.h>

double init(double x) {
return x*x+1; }

double bord(double t) {
return exp(-t); }

double w(double y) {
return -atan(exp(y*y)); }

double dw(double y) {
return -2*y*exp(-y*y)/(1+exp(2*y*y)); }

double f(double y, double y_i, double y_j, double y_ij, double tau, double h) {
return y/2/tau+w(y)/2/h+(y_i-y_ij-y_j)/2/tau+(w(y_j)-w(y_ij)-w(y_i))/2/h; }

double df(double y, double tau, double h) {
return 1/tau/2+dw(y)/h/2; }

void main(){
FILE *func;
func=fopen("2.dat","w");
int i, j, XSTEPS=100, TSTEPS=200;
double X1=0, X2=-1, h, tau=0.01, epsilon=1e-4, y0, y_i, y[XSTEPS+1][TSTEPS];
h=(X2-X1)/XSTEPS;
for (i=0; i<=XSTEPS; i++)
	y[i][0]=init(X1+h*i);
for (j=0; j<TSTEPS; j++)
	y[0][j]=bord(j*tau);
for (i=1; i<=XSTEPS; i++)
	{
	for (j=1; j<TSTEPS; j++)
		{
		y0=y_i+2*epsilon;
		y[i][j]=y_i;
		while (y0-y[i][j]>epsilon || y[i][j]-y0>epsilon) {
			y0=y[i][j];
			y[i][j]=y[i][j]-f(y[i][j],y[i-1][j],y[i][j-1],y[i-1][j-1],tau,h)/df(y[i][j],tau,h); }
		fprintf(func,"%f\t%f\t%f\n", j*tau, X1+h*i, y[i][j]);
		}
	fprintf(func,"\n");
	}
}

